from struct import pack
from enigma import *
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.Label import Label, MultiColorLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList        
from Components.Input import Input
from Components.ConfigList import ConfigList
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from Screens.ServiceInfo import *
from Plugins.Plugin import PluginDescriptor
from Tools import Notifications
from Components.config import *
from Tools.Directories import fileExists 
from Plugins.Extensions.FreeServer.outils.MyStatus import *
from Plugins.Extensions.FreeServer.outils.MyShPrombt import *
from Plugins.Extensions.FreeServer.outils.NetworkMacSetup import *
from Plugins.Extensions.FreeServer.outils.MyDynaTextScreen import *
from Plugins.Extensions.FreeServer.outils.MyKoraScreen import *
from Plugins.Extensions.FreeServer.outils.MyKoraScreen2 import *
from Plugins.Extensions.FreeServer.outils.CronTimers import *
from Plugins.Extensions.FreeServer.outils.LiseScreencccam import *
from Plugins.Extensions.FreeServer.outils.LiseScreencccam2 import *
from Plugins.Extensions.FreeServer.outils.Update import *
from Plugins.Extensions.FreeServer.outils.Showinfo import Showinfo, Showinfo1, Showinfo2, Showinfo3, Showinfo4, Showinfo5
import os
from urllib2 import Request, urlopen, URLError, HTTPError

###########################################################################

#### Add By RAED
def connected_to_internet():
    import requests
    try:
        _ = requests.get('http://upload.metabox.ru/feed/fairbird/', timeout=5)
        print("internet connection available.")
        return True
    except requests.ConnectionError:
        print("No internet connection available.")
        return False
    print connected_to_internet()
#### end

class Input(Screen):

    if DESKHEIGHT < 1000:
        skin = """
                <screen position="center,center" size="450,360" title="Input" >
                    <widget name="menu" position="10,10" size="450,360" scrollbarMode="showOnDemand" />
                </screen>"""
    else:
        skin = """
                <screen position="center,center" size="600,400" title="Input" >
                    <widget name="menu" position="0,0" size="600,400" scrollbarMode="showOnDemand" />
                </screen>"""
#### end
    def __init__(self, session, args = 0):
        self.skin = Input.skin
        self.session = session
        Screen.__init__(self, session)
### EDit By RAED To DreamOS OE2.5/2.6
        if fileExists('/var/lib/dpkg/status'):
            self.wget = "/usr/bin/wget2 --no-check-certificate"
	else:
	    self.wget = "/usr/bin/wget"
#### end
        self.menu = args
        list = []               
        list.append((_("CronTimers"), "CronTimers"))                  
        list.append((_("Last Oscam Ncam Bin -- Free Server"), "MyShPrombt"))         
        list.append((_("Last Oscam Ncam ipk Update"), "MyDynaTextScreen"))                 
        list.append((_("testious"), "LiseScreencccam")) 
        list.append((_("testious2"), "LiseScreencccam2")) 
        list.append((_("FOOT ON LINE"), "MyKoraScreen")) 
        list.append((_("KOORA ON LINE"), "MyKoraScreen2"))            
        list.append((_("lists_world"), "Showinfo"))
        list.append((_("Programetvfoot"), "Showinfo2")) 
        list.append((_("Ncamlog"), "Showinfo1")) 
        list.append((_("OScamlog"), "Showinfo4"))
        list.append((_("Mac address changer"), "NetworkMacSetup"))
        list.append((_("Update"), "Update"))                    
        list.append((_("About"), "about"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)

#    def Cronmanager_OS(self):
#        if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/Cronmanager/plugin.pyo'):
#           from Plugins.Extensions.Cronmanager.plugin.py import Cronmanager
#           self.session.open(Cronmanager)
#        else:
#           from Components.Console import Console
#           self.Console = Console()
#           wget = "/usr/bin/wget2"
#           crt = "--debug --no-check-certificate"
#           tmpfile = "/tmp/cron.deb"
#           myurl = 'https://ia600702.us.archive.org/26/items/dreamosat/enigma2-plugin-extensions-cronmanager_3.0_all.deb'
#           command = '%s -q %s %s %s' % (wget, crt, tmpfile, myurl)
#           command1 = 'depk -i %s' % (tmpfile)
#           self.Console.ePopen(command, command1)
#           self.close(self.Cronmanager_OS)

    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
### EDit By RAED
            if returnValue is "CronTimers":
                if fileExists('/var/lib/dpkg/status'):
                     from Plugins.Extensions.Cronmanager.plugin import *
		     self.session.open(Cronmanager) 
                else:
		     if connected_to_internet() == True: ## Code to find connection internet or not
		          self.session.open(CronTimers)
		     else:
		          self.session.open(MessageBox, _('Error: connection failed !'), MessageBox.TYPE_INFO, timeout=5)
            elif returnValue is "about":
                self.session.open(MyStatus)
            elif returnValue is "Showinfo1":
                if fileExists('/tmp/ncam.log'):
                      self.session.open(Showinfo1)
                else:
                      self.session.open(MessageBox,_('NCam Log Not Found'), MessageBox.TYPE_INFO, timeout=15)  
            elif returnValue is "Showinfo4":
                if fileExists('/tmp/oscam.log'):
                      self.session.open(Showinfo4)
                else:
                      self.session.open(MessageBox,_('OScam Log Not Found'), MessageBox.TYPE_INFO, timeout=15)  
            elif returnValue is "NetworkMacSetup":
                self.session.open(NetworkMacSetup)
            elif connected_to_internet() == True: ## Code to find connection internet or not
                if returnValue is "MyDynaTextScreen":
                   self.session.open(MyDynaTextScreen)                            
                elif returnValue is "LiseScreencccam":
                   self.session.open(LiseScreencccam)
                elif returnValue is "LiseScreencccam2":
                   self.session.open(LiseScreencccam2) 
                elif returnValue is "MyKoraScreen":
                   self.session.open(MyKoraScreen)   
                elif returnValue is "MyKoraScreen2":
                   self.session.open(MyKoraScreen2)                        
                elif returnValue is "Showinfo":
                  if fileExists('/tmp/freeservre79'):
                   import sys,os  
                   os.system("%s https://ia800702.us.archive.org/26/items/dreamosat/lists_world.sh -qO - | /bin/sh" % self.wget) 
                   self.session.open(Showinfo)     

                  else:
                      self.session.open(MessageBox,_('lists_world not found'), MessageBox.TYPE_INFO, timeout=15)
                elif returnValue is "Showinfo2":
                  if fileExists('/tmp/freeservre80'):
                   import sys,os  
                   os.system("%s https://ia601500.us.archive.org/32/items/FoulFreecccamserver/Programetvfoot.sh -qO - | /bin/sh" % self.wget) 
                   self.session.open(Showinfo2)
                  else:
                      self.session.open(MessageBox,_('Programe tv foot not found'), MessageBox.TYPE_INFO, timeout=15)
                elif returnValue is "MyShPrombt":
                   self.session.open(MyShPrombt) 
                elif returnValue is "Update":
                   self.session.open(Update)
            else:
                self.session.open(MessageBox, _('Error: connection failed !'), MessageBox.TYPE_INFO, timeout=5)
### End 
